-- Do not edit.  Generated by cheby 1.7.dev0 using these options:
--  --header commit --gen-hdl board_map.vhd --gen-c ../../sw/hw-include/board_map.h -i board_map.cheby


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity board_map is
  port (
    aclk                 : in    std_logic;
    areset_n             : in    std_logic;
    awvalid              : in    std_logic;
    awready              : out   std_logic;
    awaddr               : in    std_logic_vector(16 downto 2);
    awprot               : in    std_logic_vector(2 downto 0);
    wvalid               : in    std_logic;
    wready               : out   std_logic;
    wdata                : in    std_logic_vector(31 downto 0);
    wstrb                : in    std_logic_vector(3 downto 0);
    bvalid               : out   std_logic;
    bready               : in    std_logic;
    bresp                : out   std_logic_vector(1 downto 0);
    arvalid              : in    std_logic;
    arready              : out   std_logic;
    araddr               : in    std_logic_vector(16 downto 2);
    arprot               : in    std_logic_vector(2 downto 0);
    rvalid               : out   std_logic;
    rready               : in    std_logic;
    rdata                : out   std_logic_vector(31 downto 0);
    rresp                : out   std_logic_vector(1 downto 0);

    -- Map version
    map_version_i        : in    std_logic_vector(31 downto 0);

    -- Model id
    model_id_i           : in    std_logic_vector(31 downto 0);

    -- Firmware version
    fw_version_o         : out   std_logic_vector(31 downto 0);

    -- WhiteRabbit status
    wr_state_link_up_i   : in    std_logic;
    wr_state_time_valid_i : in    std_logic;

    -- TAI (seconds) lo part
    tm_tai_lo_i          : in    std_logic_vector(31 downto 0);

    -- TAI (seconds) hi part
    tm_tai_hi_i          : in    std_logic_vector(31 downto 0);

    -- TAI cycles
    tm_cycles_i          : in    std_logic_vector(31 downto 0);

    -- interrupt force
    ifr_msg_o            : out   std_logic;
    ifr_async_o          : out   std_logic;
    ifr_wr_o             : out   std_logic;

    -- Front panel 50ohm termination enable
    fp_term_o            : out   std_logic_vector(31 downto 0);

    -- Front panel input polarity inversion
    fp_inv_o             : out   std_logic_vector(31 downto 0);

    -- Front panel output enable
    fp_oe_o              : out   std_logic_vector(31 downto 0);

    -- Invert userio inputs
    userio_inv_o         : out   std_logic_vector(31 downto 0);

    -- Value of userio inputs
    userio_in_i          : in    std_logic_vector(31 downto 0);

    -- Control userio (extra inputs and outputs)
    -- 0: input, 1: output; control fpga driver direction
    userio_cfg_dir_o     : out   std_logic_vector(3 downto 0);
    -- userio driver enable
    userio_cfg_en_o      : out   std_logic_vector(3 downto 0);
    -- enable patch panel output
    userio_cfg_pp_en_o   : out   std_logic;

    -- Raw pulsers status (WTC)
    pulsers_raw_i        : in    std_logic_vector(31 downto 0);

    -- Pulsers status (WTC)
    pulsers_int_i        : in    std_logic_vector(31 downto 0);

    -- Mask for pulsers status
    pulsers_mask_o       : out   std_logic_vector(31 downto 0);

    -- Switches, id and geographical address
    board_id_switches_i  : in    std_logic_vector(7 downto 0);
    board_id_fp_id_i     : in    std_logic_vector(2 downto 0);
    board_id_pp_id_i     : in    std_logic_vector(2 downto 0);
    board_id_vme_ga_i    : in    std_logic_vector(5 downto 0);

    -- mux for PXIe DSTAR-C lines
    pxie_dstarc_mux_o    : out   std_logic_vector(7 downto 0);

    -- mux for PXIe DSTAR-A lines
    pxie_dstara_mux_o    : out   std_logic_vector(2 downto 0);

    -- WR Fabric demux fifo level (to observe)
    nic_fifo_max_count_i : in    std_logic_vector(15 downto 0);
    nic_fifo_full_i      : in    std_logic;

    -- WB bus si5340
    si5340_i             : in    t_wishbone_master_in;
    si5340_o             : out   t_wishbone_master_out;

    -- Set when leds are controlled by the colors memory
    leds_force_o         : out   std_logic_vector(31 downto 0);

    -- Led color for an active output
    leds_rgb_out_hi_o    : out   std_logic_vector(31 downto 0);

    -- Led color for an inactive output
    leds_rgb_out_lo_o    : out   std_logic_vector(31 downto 0);

    -- Led color for an active input
    leds_rgb_in_hi_o     : out   std_logic_vector(31 downto 0);

    -- Led color for an inactive input
    leds_rgb_in_lo_o     : out   std_logic_vector(31 downto 0);

    -- Colors of the leds when forced
    leds_colors_adr_o    : out   std_logic_vector(7 downto 2);
    leds_colors_dato_i   : in    std_logic_vector(31 downto 0);
    leds_colors_dati_o   : out   std_logic_vector(31 downto 0);
    leds_colors_rd_o     : out   std_logic;
    leds_colors_wr_o     : out   std_logic;
    leds_colors_rack_i   : in    std_logic;
    leds_colors_wack_i   : in    std_logic;

    -- REG ftw_hi
    rf_0_ftw_hi_o        : out   std_logic_vector(31 downto 0);

    -- REG ftw_lo
    rf_0_ftw_lo_o        : out   std_logic_vector(31 downto 0);

    -- REG ftw_load
    rf_0_ftw_load_en_o   : out   std_logic;
    rf_0_ftw_load_reset_o : out   std_logic;
    rf_0_ftw_load_rfframe_o : out   std_logic;
    rf_0_ftw_load_wr_o   : out   std_logic;

    -- REG bst_ctrl
    -- enable BST encoding
    rf_0_bst_ctrl_en_o   : out   std_logic;

    -- REG h1
    rf_0_h1_o            : out   std_logic_vector(31 downto 0);

    -- REG gth_cfg
    rf_0_gth_cfg_o       : out   std_logic_vector(31 downto 0);

    -- REG gth_sta
    rf_0_gth_sta_i       : in    std_logic_vector(31 downto 0);

    -- REG rf_ftw
    rf_0_rf_ftw_hi_i     : in    std_logic_vector(15 downto 0);
    rf_0_rf_ftw_rst_i    : in    std_logic;

    -- REG rf_ftw_lo
    rf_0_rf_ftw_lo_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_tai
    rf_0_rf_rx_tai_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_cyc
    rf_0_rf_rx_cyc_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_sta
    rf_0_rf_rx_sta_valid_i : in    std_logic;

    -- WB bus streamer
    rf_0_streamer_i      : in    t_wishbone_master_in;
    rf_0_streamer_o      : out   t_wishbone_master_out;

    -- REG ftw_hi
    rf_1_ftw_hi_o        : out   std_logic_vector(31 downto 0);

    -- REG ftw_lo
    rf_1_ftw_lo_o        : out   std_logic_vector(31 downto 0);

    -- REG ftw_load
    rf_1_ftw_load_en_o   : out   std_logic;
    rf_1_ftw_load_reset_o : out   std_logic;
    rf_1_ftw_load_rfframe_o : out   std_logic;
    rf_1_ftw_load_wr_o   : out   std_logic;

    -- REG bst_ctrl
    -- enable BST encoding
    rf_1_bst_ctrl_en_o   : out   std_logic;

    -- REG h1
    rf_1_h1_o            : out   std_logic_vector(31 downto 0);

    -- REG gth_cfg
    rf_1_gth_cfg_o       : out   std_logic_vector(31 downto 0);

    -- REG gth_sta
    rf_1_gth_sta_i       : in    std_logic_vector(31 downto 0);

    -- REG rf_ftw
    rf_1_rf_ftw_hi_i     : in    std_logic_vector(15 downto 0);
    rf_1_rf_ftw_rst_i    : in    std_logic;

    -- REG rf_ftw_lo
    rf_1_rf_ftw_lo_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_tai
    rf_1_rf_rx_tai_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_cyc
    rf_1_rf_rx_cyc_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_sta
    rf_1_rf_rx_sta_valid_i : in    std_logic;

    -- WB bus streamer
    rf_1_streamer_i      : in    t_wishbone_master_in;
    rf_1_streamer_o      : out   t_wishbone_master_out;

    -- REG ftw_hi
    rf_2_ftw_hi_o        : out   std_logic_vector(31 downto 0);

    -- REG ftw_lo
    rf_2_ftw_lo_o        : out   std_logic_vector(31 downto 0);

    -- REG ftw_load
    rf_2_ftw_load_en_o   : out   std_logic;
    rf_2_ftw_load_reset_o : out   std_logic;
    rf_2_ftw_load_rfframe_o : out   std_logic;
    rf_2_ftw_load_wr_o   : out   std_logic;

    -- REG bst_ctrl
    -- enable BST encoding
    rf_2_bst_ctrl_en_o   : out   std_logic;

    -- REG h1
    rf_2_h1_o            : out   std_logic_vector(31 downto 0);

    -- REG gth_cfg
    rf_2_gth_cfg_o       : out   std_logic_vector(31 downto 0);

    -- REG gth_sta
    rf_2_gth_sta_i       : in    std_logic_vector(31 downto 0);

    -- REG rf_ftw
    rf_2_rf_ftw_hi_i     : in    std_logic_vector(15 downto 0);
    rf_2_rf_ftw_rst_i    : in    std_logic;

    -- REG rf_ftw_lo
    rf_2_rf_ftw_lo_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_tai
    rf_2_rf_rx_tai_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_cyc
    rf_2_rf_rx_cyc_i     : in    std_logic_vector(31 downto 0);

    -- REG rf_rx_sta
    rf_2_rf_rx_sta_valid_i : in    std_logic;

    -- WB bus streamer
    rf_2_streamer_i      : in    t_wishbone_master_in;
    rf_2_streamer_o      : out   t_wishbone_master_out;

    -- Rise bit summary (one bit for each rise_sr register)
    inputs_summary_rise_i : in    std_logic_vector(2 downto 0);
    inputs_summary_fall_i : in    std_logic_vector(2 downto 0);

    -- Enable saving timestamps on edges
    inputs_csr_0_en_o    : out   std_logic_vector(31 downto 0);

    -- Set by HW when a rising edge is detected.
    -- Write 1 to clear the bit (as well as the bit in fall_sr) and
    -- re-enable timestamping.

    inputs_csr_0_rise_sr_i : in    std_logic_vector(31 downto 0);
    inputs_csr_0_rise_sr_o : out   std_logic_vector(31 downto 0);
    inputs_csr_0_rise_sr_wr_o : out   std_logic;

    -- Set by HW when the falling edge has been detected
    inputs_csr_0_fall_sr_i : in    std_logic_vector(31 downto 0);

    -- Enable saving timestamps on edges
    inputs_csr_1_en_o    : out   std_logic_vector(31 downto 0);

    -- Set by HW when a rising edge is detected.
    -- Write 1 to clear the bit (as well as the bit in fall_sr) and
    -- re-enable timestamping.

    inputs_csr_1_rise_sr_i : in    std_logic_vector(31 downto 0);
    inputs_csr_1_rise_sr_o : out   std_logic_vector(31 downto 0);
    inputs_csr_1_rise_sr_wr_o : out   std_logic;

    -- Set by HW when the falling edge has been detected
    inputs_csr_1_fall_sr_i : in    std_logic_vector(31 downto 0);

    -- Enable saving timestamps on edges
    inputs_csr_2_en_o    : out   std_logic_vector(31 downto 0);

    -- Set by HW when a rising edge is detected.
    -- Write 1 to clear the bit (as well as the bit in fall_sr) and
    -- re-enable timestamping.

    inputs_csr_2_rise_sr_i : in    std_logic_vector(31 downto 0);
    inputs_csr_2_rise_sr_o : out   std_logic_vector(31 downto 0);
    inputs_csr_2_rise_sr_wr_o : out   std_logic;

    -- Set by HW when the falling edge has been detected
    inputs_csr_2_fall_sr_i : in    std_logic_vector(31 downto 0);

    -- SRAM bus inputs_ts
    inputs_ts_addr_o     : out   std_logic_vector(10 downto 2);
    inputs_ts_data_i     : in    std_logic_vector(31 downto 0);

    -- submap for pulser group
    pulser_group_0_el_i  : in    t_wishbone_master_in;
    pulser_group_0_el_o  : out   t_wishbone_master_out;

    -- submap for pulser group
    pulser_group_1_el_i  : in    t_wishbone_master_in;
    pulser_group_1_el_o  : out   t_wishbone_master_out;

    -- submap for pulser group
    pulser_group_2_el_i  : in    t_wishbone_master_in;
    pulser_group_2_el_o  : out   t_wishbone_master_out;

    -- submap for pulser group
    pulser_group_3_el_i  : in    t_wishbone_master_in;
    pulser_group_3_el_o  : out   t_wishbone_master_out;

    -- NIC interface
    wrnic_i              : in    t_wishbone_master_in;
    wrnic_o              : out   t_wishbone_master_out
  );
end board_map;

architecture syn of board_map is
  signal wr_req                         : std_logic;
  signal wr_ack                         : std_logic;
  signal wr_addr                        : std_logic_vector(16 downto 2);
  signal wr_data                        : std_logic_vector(31 downto 0);
  signal wr_sel                         : std_logic_vector(31 downto 0);
  signal axi_awset                      : std_logic;
  signal axi_wset                       : std_logic;
  signal axi_wdone                      : std_logic;
  signal rd_req                         : std_logic;
  signal rd_ack                         : std_logic;
  signal rd_addr                        : std_logic_vector(16 downto 2);
  signal rd_data                        : std_logic_vector(31 downto 0);
  signal axi_arset                      : std_logic;
  signal axi_rdone                      : std_logic;
  signal fw_version_reg                 : std_logic_vector(31 downto 0);
  signal fw_version_wreq                : std_logic;
  signal fw_version_wack                : std_logic;
  signal ifr_wreq                       : std_logic;
  signal fp_term_reg                    : std_logic_vector(31 downto 0);
  signal fp_term_wreq                   : std_logic;
  signal fp_term_wack                   : std_logic;
  signal fp_inv_reg                     : std_logic_vector(31 downto 0);
  signal fp_inv_wreq                    : std_logic;
  signal fp_inv_wack                    : std_logic;
  signal fp_oe_reg                      : std_logic_vector(31 downto 0);
  signal fp_oe_wreq                     : std_logic;
  signal fp_oe_wack                     : std_logic;
  signal userio_inv_reg                 : std_logic_vector(31 downto 0);
  signal userio_inv_wreq                : std_logic;
  signal userio_inv_wack                : std_logic;
  signal userio_cfg_dir_reg             : std_logic_vector(3 downto 0);
  signal userio_cfg_en_reg              : std_logic_vector(3 downto 0);
  signal userio_cfg_pp_en_reg           : std_logic;
  signal userio_cfg_wreq                : std_logic;
  signal userio_cfg_wack                : std_logic;
  signal pulsers_raw_reg                : std_logic_vector(31 downto 0);
  signal pulsers_raw_wreq               : std_logic;
  signal pulsers_raw_wack               : std_logic;
  signal pulsers_int_reg                : std_logic_vector(31 downto 0);
  signal pulsers_int_wreq               : std_logic;
  signal pulsers_int_wack               : std_logic;
  signal pulsers_mask_reg               : std_logic_vector(31 downto 0);
  signal pulsers_mask_wreq              : std_logic;
  signal pulsers_mask_wack              : std_logic;
  signal pxie_dstarc_mux_reg            : std_logic_vector(7 downto 0);
  signal pxie_dstarc_wreq               : std_logic;
  signal pxie_dstarc_wack               : std_logic;
  signal pxie_dstara_mux_reg            : std_logic_vector(2 downto 0);
  signal pxie_dstara_wreq               : std_logic;
  signal pxie_dstara_wack               : std_logic;
  signal si5340_re                      : std_logic;
  signal si5340_we                      : std_logic;
  signal si5340_wt                      : std_logic;
  signal si5340_rt                      : std_logic;
  signal si5340_tr                      : std_logic;
  signal si5340_wack                    : std_logic;
  signal si5340_rack                    : std_logic;
  signal si5340_wr                      : std_logic;
  signal si5340_rr                      : std_logic;
  signal leds_force_reg                 : std_logic_vector(31 downto 0);
  signal leds_force_wreq                : std_logic;
  signal leds_force_wack                : std_logic;
  signal leds_rgb_out_hi_reg            : std_logic_vector(31 downto 0);
  signal leds_rgb_out_hi_wreq           : std_logic;
  signal leds_rgb_out_hi_wack           : std_logic;
  signal leds_rgb_out_lo_reg            : std_logic_vector(31 downto 0);
  signal leds_rgb_out_lo_wreq           : std_logic;
  signal leds_rgb_out_lo_wack           : std_logic;
  signal leds_rgb_in_hi_reg             : std_logic_vector(31 downto 0);
  signal leds_rgb_in_hi_wreq            : std_logic;
  signal leds_rgb_in_hi_wack            : std_logic;
  signal leds_rgb_in_lo_reg             : std_logic_vector(31 downto 0);
  signal leds_rgb_in_lo_wreq            : std_logic;
  signal leds_rgb_in_lo_wack            : std_logic;
  signal leds_colors_wr                 : std_logic;
  signal leds_colors_rr                 : std_logic;
  signal leds_colors_ws                 : std_logic;
  signal leds_colors_rs                 : std_logic;
  signal leds_colors_re                 : std_logic;
  signal leds_colors_we                 : std_logic;
  signal leds_colors_wt                 : std_logic;
  signal leds_colors_rt                 : std_logic;
  signal rf_0_ftw_hi_reg                : std_logic_vector(31 downto 0);
  signal rf_0_ftw_hi_wreq               : std_logic;
  signal rf_0_ftw_hi_wack               : std_logic;
  signal rf_0_ftw_lo_reg                : std_logic_vector(31 downto 0);
  signal rf_0_ftw_lo_wreq               : std_logic;
  signal rf_0_ftw_lo_wack               : std_logic;
  signal rf_0_ftw_load_wreq             : std_logic;
  signal rf_0_bst_ctrl_en_reg           : std_logic;
  signal rf_0_bst_ctrl_wreq             : std_logic;
  signal rf_0_bst_ctrl_wack             : std_logic;
  signal rf_0_h1_reg                    : std_logic_vector(31 downto 0);
  signal rf_0_h1_wreq                   : std_logic;
  signal rf_0_h1_wack                   : std_logic;
  signal rf_0_gth_cfg_reg               : std_logic_vector(31 downto 0);
  signal rf_0_gth_cfg_wreq              : std_logic;
  signal rf_0_gth_cfg_wack              : std_logic;
  signal rf_0_rf_rx_sta_valid_reg       : std_logic;
  signal rf_0_rf_rx_sta_wreq            : std_logic;
  signal rf_0_rf_rx_sta_wack            : std_logic;
  signal rf_0_streamer_re               : std_logic;
  signal rf_0_streamer_we               : std_logic;
  signal rf_0_streamer_wt               : std_logic;
  signal rf_0_streamer_rt               : std_logic;
  signal rf_0_streamer_tr               : std_logic;
  signal rf_0_streamer_wack             : std_logic;
  signal rf_0_streamer_rack             : std_logic;
  signal rf_0_streamer_wr               : std_logic;
  signal rf_0_streamer_rr               : std_logic;
  signal rf_1_ftw_hi_reg                : std_logic_vector(31 downto 0);
  signal rf_1_ftw_hi_wreq               : std_logic;
  signal rf_1_ftw_hi_wack               : std_logic;
  signal rf_1_ftw_lo_reg                : std_logic_vector(31 downto 0);
  signal rf_1_ftw_lo_wreq               : std_logic;
  signal rf_1_ftw_lo_wack               : std_logic;
  signal rf_1_ftw_load_wreq             : std_logic;
  signal rf_1_bst_ctrl_en_reg           : std_logic;
  signal rf_1_bst_ctrl_wreq             : std_logic;
  signal rf_1_bst_ctrl_wack             : std_logic;
  signal rf_1_h1_reg                    : std_logic_vector(31 downto 0);
  signal rf_1_h1_wreq                   : std_logic;
  signal rf_1_h1_wack                   : std_logic;
  signal rf_1_gth_cfg_reg               : std_logic_vector(31 downto 0);
  signal rf_1_gth_cfg_wreq              : std_logic;
  signal rf_1_gth_cfg_wack              : std_logic;
  signal rf_1_rf_rx_sta_valid_reg       : std_logic;
  signal rf_1_rf_rx_sta_wreq            : std_logic;
  signal rf_1_rf_rx_sta_wack            : std_logic;
  signal rf_1_streamer_re               : std_logic;
  signal rf_1_streamer_we               : std_logic;
  signal rf_1_streamer_wt               : std_logic;
  signal rf_1_streamer_rt               : std_logic;
  signal rf_1_streamer_tr               : std_logic;
  signal rf_1_streamer_wack             : std_logic;
  signal rf_1_streamer_rack             : std_logic;
  signal rf_1_streamer_wr               : std_logic;
  signal rf_1_streamer_rr               : std_logic;
  signal rf_2_ftw_hi_reg                : std_logic_vector(31 downto 0);
  signal rf_2_ftw_hi_wreq               : std_logic;
  signal rf_2_ftw_hi_wack               : std_logic;
  signal rf_2_ftw_lo_reg                : std_logic_vector(31 downto 0);
  signal rf_2_ftw_lo_wreq               : std_logic;
  signal rf_2_ftw_lo_wack               : std_logic;
  signal rf_2_ftw_load_wreq             : std_logic;
  signal rf_2_bst_ctrl_en_reg           : std_logic;
  signal rf_2_bst_ctrl_wreq             : std_logic;
  signal rf_2_bst_ctrl_wack             : std_logic;
  signal rf_2_h1_reg                    : std_logic_vector(31 downto 0);
  signal rf_2_h1_wreq                   : std_logic;
  signal rf_2_h1_wack                   : std_logic;
  signal rf_2_gth_cfg_reg               : std_logic_vector(31 downto 0);
  signal rf_2_gth_cfg_wreq              : std_logic;
  signal rf_2_gth_cfg_wack              : std_logic;
  signal rf_2_rf_rx_sta_valid_reg       : std_logic;
  signal rf_2_rf_rx_sta_wreq            : std_logic;
  signal rf_2_rf_rx_sta_wack            : std_logic;
  signal rf_2_streamer_re               : std_logic;
  signal rf_2_streamer_we               : std_logic;
  signal rf_2_streamer_wt               : std_logic;
  signal rf_2_streamer_rt               : std_logic;
  signal rf_2_streamer_tr               : std_logic;
  signal rf_2_streamer_wack             : std_logic;
  signal rf_2_streamer_rack             : std_logic;
  signal rf_2_streamer_wr               : std_logic;
  signal rf_2_streamer_rr               : std_logic;
  signal inputs_csr_0_en_reg            : std_logic_vector(31 downto 0);
  signal inputs_csr_0_en_wreq           : std_logic;
  signal inputs_csr_0_en_wack           : std_logic;
  signal inputs_csr_0_rise_sr_wreq      : std_logic;
  signal inputs_csr_1_en_reg            : std_logic_vector(31 downto 0);
  signal inputs_csr_1_en_wreq           : std_logic;
  signal inputs_csr_1_en_wack           : std_logic;
  signal inputs_csr_1_rise_sr_wreq      : std_logic;
  signal inputs_csr_2_en_reg            : std_logic_vector(31 downto 0);
  signal inputs_csr_2_en_wreq           : std_logic;
  signal inputs_csr_2_en_wack           : std_logic;
  signal inputs_csr_2_rise_sr_wreq      : std_logic;
  signal inputs_ts_rack                 : std_logic;
  signal inputs_ts_re                   : std_logic;
  signal pulser_group_0_el_re           : std_logic;
  signal pulser_group_0_el_we           : std_logic;
  signal pulser_group_0_el_wt           : std_logic;
  signal pulser_group_0_el_rt           : std_logic;
  signal pulser_group_0_el_tr           : std_logic;
  signal pulser_group_0_el_wack         : std_logic;
  signal pulser_group_0_el_rack         : std_logic;
  signal pulser_group_0_el_wr           : std_logic;
  signal pulser_group_0_el_rr           : std_logic;
  signal pulser_group_1_el_re           : std_logic;
  signal pulser_group_1_el_we           : std_logic;
  signal pulser_group_1_el_wt           : std_logic;
  signal pulser_group_1_el_rt           : std_logic;
  signal pulser_group_1_el_tr           : std_logic;
  signal pulser_group_1_el_wack         : std_logic;
  signal pulser_group_1_el_rack         : std_logic;
  signal pulser_group_1_el_wr           : std_logic;
  signal pulser_group_1_el_rr           : std_logic;
  signal pulser_group_2_el_re           : std_logic;
  signal pulser_group_2_el_we           : std_logic;
  signal pulser_group_2_el_wt           : std_logic;
  signal pulser_group_2_el_rt           : std_logic;
  signal pulser_group_2_el_tr           : std_logic;
  signal pulser_group_2_el_wack         : std_logic;
  signal pulser_group_2_el_rack         : std_logic;
  signal pulser_group_2_el_wr           : std_logic;
  signal pulser_group_2_el_rr           : std_logic;
  signal pulser_group_3_el_re           : std_logic;
  signal pulser_group_3_el_we           : std_logic;
  signal pulser_group_3_el_wt           : std_logic;
  signal pulser_group_3_el_rt           : std_logic;
  signal pulser_group_3_el_tr           : std_logic;
  signal pulser_group_3_el_wack         : std_logic;
  signal pulser_group_3_el_rack         : std_logic;
  signal pulser_group_3_el_wr           : std_logic;
  signal pulser_group_3_el_rr           : std_logic;
  signal wrnic_re                       : std_logic;
  signal wrnic_we                       : std_logic;
  signal wrnic_wt                       : std_logic;
  signal wrnic_rt                       : std_logic;
  signal wrnic_tr                       : std_logic;
  signal wrnic_wack                     : std_logic;
  signal wrnic_rack                     : std_logic;
  signal wrnic_wr                       : std_logic;
  signal wrnic_rr                       : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(16 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(31 downto 0);
begin

  -- AW, W and B channels
  awready <= not axi_awset;
  wready <= not axi_wset;
  bvalid <= axi_wdone;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        wr_req <= '0';
        axi_awset <= '0';
        axi_wset <= '0';
        axi_wdone <= '0';
      else
        wr_req <= '0';
        if awvalid = '1' and axi_awset = '0' then
          wr_addr <= awaddr;
          axi_awset <= '1';
          wr_req <= axi_wset;
        end if;
        if wvalid = '1' and axi_wset = '0' then
          wr_data <= wdata;
          wr_sel(7 downto 0) <= (others => wstrb(0));
          wr_sel(15 downto 8) <= (others => wstrb(1));
          wr_sel(23 downto 16) <= (others => wstrb(2));
          wr_sel(31 downto 24) <= (others => wstrb(3));
          axi_wset <= '1';
          wr_req <= axi_awset or awvalid;
        end if;
        if (axi_wdone and bready) = '1' then
          axi_wset <= '0';
          axi_awset <= '0';
          axi_wdone <= '0';
        end if;
        if wr_ack = '1' then
          axi_wdone <= '1';
        end if;
      end if;
    end if;
  end process;
  bresp <= "00";

  -- AR and R channels
  arready <= not axi_arset;
  rvalid <= axi_rdone;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rd_req <= '0';
        axi_arset <= '0';
        axi_rdone <= '0';
        rdata <= (others => '0');
      else
        rd_req <= '0';
        if arvalid = '1' and axi_arset = '0' then
          rd_addr <= araddr;
          axi_arset <= '1';
          rd_req <= '1';
        end if;
        if (axi_rdone and rready) = '1' then
          axi_arset <= '0';
          axi_rdone <= '0';
        end if;
        if rd_ack = '1' then
          axi_rdone <= '1';
          rdata <= rd_data;
        end if;
      end if;
    end if;
  end process;
  rresp <= "00";

  -- pipelining for wr-in+rd-out
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rd_ack <= '0';
        rd_data <= "00000000000000000000000000000000";
        wr_req_d0 <= '0';
        wr_adr_d0 <= "000000000000000";
        wr_dat_d0 <= "00000000000000000000000000000000";
        wr_sel_d0 <= "00000000000000000000000000000000";
      else
        rd_ack <= rd_ack_d0;
        rd_data <= rd_dat_d0;
        wr_req_d0 <= wr_req;
        wr_adr_d0 <= wr_addr;
        wr_dat_d0 <= wr_data;
        wr_sel_d0 <= wr_sel;
      end if;
    end if;
  end process;

  -- Register map_version

  -- Register model_id

  -- Register fw_version
  fw_version_o <= fw_version_reg;
  fw_version_wack <= fw_version_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        fw_version_reg <= "00000000000000000000000000000000";
      else
        if fw_version_wreq = '1' then
          fw_version_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register wr_state

  -- Register tm_tai_lo

  -- Register tm_tai_hi

  -- Register tm_cycles

  -- Register ifr
  ifr_msg_o <= wr_dat_d0(3);
  ifr_async_o <= wr_dat_d0(4);
  ifr_wr_o <= ifr_wreq;

  -- Register fp_term
  fp_term_o <= fp_term_reg;
  fp_term_wack <= fp_term_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        fp_term_reg <= "00000000000000000000000000000000";
      else
        if fp_term_wreq = '1' then
          fp_term_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register fp_inv
  fp_inv_o <= fp_inv_reg;
  fp_inv_wack <= fp_inv_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        fp_inv_reg <= "00000000000000000000000000000000";
      else
        if fp_inv_wreq = '1' then
          fp_inv_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register fp_oe
  fp_oe_o <= fp_oe_reg;
  fp_oe_wack <= fp_oe_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        fp_oe_reg <= "00000000000000000000000000000000";
      else
        if fp_oe_wreq = '1' then
          fp_oe_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register userio_inv
  userio_inv_o <= userio_inv_reg;
  userio_inv_wack <= userio_inv_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        userio_inv_reg <= "00000000000000000000000000000000";
      else
        if userio_inv_wreq = '1' then
          userio_inv_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register userio_in

  -- Register userio_cfg
  userio_cfg_dir_o <= userio_cfg_dir_reg;
  userio_cfg_en_o <= userio_cfg_en_reg;
  userio_cfg_pp_en_o <= userio_cfg_pp_en_reg;
  userio_cfg_wack <= userio_cfg_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        userio_cfg_dir_reg <= "0000";
        userio_cfg_en_reg <= "0000";
        userio_cfg_pp_en_reg <= '0';
      else
        if userio_cfg_wreq = '1' then
          userio_cfg_dir_reg <= wr_dat_d0(3 downto 0);
          userio_cfg_en_reg <= wr_dat_d0(7 downto 4);
          userio_cfg_pp_en_reg <= wr_dat_d0(8);
        end if;
      end if;
    end if;
  end process;

  -- Register pulsers_raw
  pulsers_raw_wack <= pulsers_raw_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulsers_raw_reg <= "00000000000000000000000000000000";
      else
        if pulsers_raw_wreq = '1' then
          pulsers_raw_reg <= pulsers_raw_i or (pulsers_raw_reg and not wr_dat_d0);
        else
          pulsers_raw_reg <= pulsers_raw_i or pulsers_raw_reg;
        end if;
      end if;
    end if;
  end process;

  -- Register pulsers_int
  pulsers_int_wack <= pulsers_int_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulsers_int_reg <= "00000000000000000000000000000000";
      else
        if pulsers_int_wreq = '1' then
          pulsers_int_reg <= pulsers_int_i or (pulsers_int_reg and not wr_dat_d0);
        else
          pulsers_int_reg <= pulsers_int_i or pulsers_int_reg;
        end if;
      end if;
    end if;
  end process;

  -- Register pulsers_mask
  pulsers_mask_o <= pulsers_mask_reg;
  pulsers_mask_wack <= pulsers_mask_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulsers_mask_reg <= "00000000000000000000000000000000";
      else
        if pulsers_mask_wreq = '1' then
          pulsers_mask_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register board_id

  -- Register pxie_dstarc
  pxie_dstarc_mux_o <= pxie_dstarc_mux_reg;
  pxie_dstarc_wack <= pxie_dstarc_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pxie_dstarc_mux_reg <= "00000000";
      else
        if pxie_dstarc_wreq = '1' then
          pxie_dstarc_mux_reg <= wr_dat_d0(7 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register pxie_dstara
  pxie_dstara_mux_o <= pxie_dstara_mux_reg;
  pxie_dstara_wack <= pxie_dstara_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pxie_dstara_mux_reg <= "000";
      else
        if pxie_dstara_wreq = '1' then
          pxie_dstara_mux_reg <= wr_dat_d0(2 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register nic_fifo

  -- Interface si5340
  si5340_tr <= si5340_wt or si5340_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        si5340_rt <= '0';
        si5340_wt <= '0';
        si5340_wr <= '0';
        si5340_rr <= '0';
      else
        si5340_wr <= (si5340_wr or si5340_we) and not si5340_wack;
        si5340_wt <= (si5340_wt or (si5340_wr and not si5340_tr)) and not si5340_wack;
        si5340_rr <= (si5340_rr or si5340_re) and not si5340_rack;
        si5340_rt <= (si5340_rt or (si5340_rr and not (si5340_wr or si5340_tr))) and not si5340_rack;
      end if;
    end if;
  end process;
  si5340_o.cyc <= si5340_tr;
  si5340_o.stb <= si5340_tr;
  si5340_wack <= si5340_i.ack and si5340_wt;
  si5340_rack <= si5340_i.ack and si5340_rt;
  process (rd_addr, wr_adr_d0, si5340_wt) begin
    if si5340_wt = '1' then
      si5340_o.adr <= ((24 downto 0 => '0') & wr_adr_d0(6 downto 2)) & (1 downto 0 => '0');
    else
      si5340_o.adr <= ((24 downto 0 => '0') & rd_addr(6 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    si5340_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      si5340_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      si5340_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      si5340_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      si5340_o.sel(3) <= '1';
    end if;
  end process;
  si5340_o.we <= si5340_wt;
  si5340_o.dat <= wr_dat_d0;

  -- Register leds_force
  leds_force_o <= leds_force_reg;
  leds_force_wack <= leds_force_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        leds_force_reg <= "00000000000000000000000000000000";
      else
        if leds_force_wreq = '1' then
          leds_force_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register leds_rgb_out_hi
  leds_rgb_out_hi_o <= leds_rgb_out_hi_reg;
  leds_rgb_out_hi_wack <= leds_rgb_out_hi_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        leds_rgb_out_hi_reg <= "00000000111111111010010100000000";
      else
        if leds_rgb_out_hi_wreq = '1' then
          leds_rgb_out_hi_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register leds_rgb_out_lo
  leds_rgb_out_lo_o <= leds_rgb_out_lo_reg;
  leds_rgb_out_lo_wack <= leds_rgb_out_lo_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        leds_rgb_out_lo_reg <= "00000000000000110000001000000000";
      else
        if leds_rgb_out_lo_wreq = '1' then
          leds_rgb_out_lo_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register leds_rgb_in_hi
  leds_rgb_in_hi_o <= leds_rgb_in_hi_reg;
  leds_rgb_in_hi_wack <= leds_rgb_in_hi_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        leds_rgb_in_hi_reg <= "00000000010010110000000010000010";
      else
        if leds_rgb_in_hi_wreq = '1' then
          leds_rgb_in_hi_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register leds_rgb_in_lo
  leds_rgb_in_lo_o <= leds_rgb_in_lo_reg;
  leds_rgb_in_lo_wack <= leds_rgb_in_lo_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        leds_rgb_in_lo_reg <= "00000000000000010000000000000010";
      else
        if leds_rgb_in_lo_wreq = '1' then
          leds_rgb_in_lo_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Interface leds_colors
  leds_colors_dati_o <= wr_dat_d0;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        leds_colors_wr <= '0';
        leds_colors_wt <= '0';
        leds_colors_rr <= '0';
        leds_colors_rt <= '0';
      else
        leds_colors_wr <= (leds_colors_wr or leds_colors_we) and not leds_colors_wack_i;
        leds_colors_wt <= (leds_colors_wt or leds_colors_ws) and not leds_colors_wack_i;
        leds_colors_rr <= (leds_colors_rr or leds_colors_re) and not leds_colors_rack_i;
        leds_colors_rt <= (leds_colors_rt or leds_colors_rs) and not leds_colors_rack_i;
      end if;
    end if;
  end process;
  leds_colors_rs <= leds_colors_rr and not (leds_colors_wr or (leds_colors_rt or leds_colors_wt));
  leds_colors_ws <= leds_colors_wr and not (leds_colors_rt or leds_colors_wt);
  process (rd_addr, wr_adr_d0, leds_colors_wt, leds_colors_ws) begin
    if (leds_colors_ws or leds_colors_wt) = '1' then
      leds_colors_adr_o <= wr_adr_d0(7 downto 2);
    else
      leds_colors_adr_o <= rd_addr(7 downto 2);
    end if;
  end process;

  -- Register rf_0_ftw_hi
  rf_0_ftw_hi_o <= rf_0_ftw_hi_reg;
  rf_0_ftw_hi_wack <= rf_0_ftw_hi_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_ftw_hi_reg <= "00000000000000000000000000000000";
      else
        if rf_0_ftw_hi_wreq = '1' then
          rf_0_ftw_hi_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_0_ftw_lo
  rf_0_ftw_lo_o <= rf_0_ftw_lo_reg;
  rf_0_ftw_lo_wack <= rf_0_ftw_lo_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_ftw_lo_reg <= "00000000000000000000000000000000";
      else
        if rf_0_ftw_lo_wreq = '1' then
          rf_0_ftw_lo_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_0_ftw_load
  rf_0_ftw_load_en_o <= wr_dat_d0(0);
  rf_0_ftw_load_reset_o <= wr_dat_d0(1);
  rf_0_ftw_load_rfframe_o <= wr_dat_d0(2);
  rf_0_ftw_load_wr_o <= rf_0_ftw_load_wreq;

  -- Register rf_0_bst_ctrl
  rf_0_bst_ctrl_en_o <= rf_0_bst_ctrl_en_reg;
  rf_0_bst_ctrl_wack <= rf_0_bst_ctrl_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_bst_ctrl_en_reg <= '0';
      else
        if rf_0_bst_ctrl_wreq = '1' then
          rf_0_bst_ctrl_en_reg <= wr_dat_d0(0);
        end if;
      end if;
    end if;
  end process;

  -- Register rf_0_h1
  rf_0_h1_o <= rf_0_h1_reg;
  rf_0_h1_wack <= rf_0_h1_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_h1_reg <= "00000000000000000000000000000000";
      else
        if rf_0_h1_wreq = '1' then
          rf_0_h1_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_0_gth_cfg
  rf_0_gth_cfg_o <= rf_0_gth_cfg_reg;
  rf_0_gth_cfg_wack <= rf_0_gth_cfg_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_gth_cfg_reg <= "00000000000000000000000000000000";
      else
        if rf_0_gth_cfg_wreq = '1' then
          rf_0_gth_cfg_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_0_gth_sta

  -- Register rf_0_rf_ftw

  -- Register rf_0_rf_ftw_lo

  -- Register rf_0_rf_rx_tai

  -- Register rf_0_rf_rx_cyc

  -- Register rf_0_rf_rx_sta
  rf_0_rf_rx_sta_wack <= rf_0_rf_rx_sta_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_rf_rx_sta_valid_reg <= '0';
      else
        if rf_0_rf_rx_sta_wreq = '1' then
          rf_0_rf_rx_sta_valid_reg <= rf_0_rf_rx_sta_valid_i or (rf_0_rf_rx_sta_valid_reg and not wr_dat_d0(0));
        else
          rf_0_rf_rx_sta_valid_reg <= rf_0_rf_rx_sta_valid_i or rf_0_rf_rx_sta_valid_reg;
        end if;
      end if;
    end if;
  end process;

  -- Interface rf_0_streamer
  rf_0_streamer_tr <= rf_0_streamer_wt or rf_0_streamer_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_0_streamer_rt <= '0';
        rf_0_streamer_wt <= '0';
        rf_0_streamer_wr <= '0';
        rf_0_streamer_rr <= '0';
      else
        rf_0_streamer_wr <= (rf_0_streamer_wr or rf_0_streamer_we) and not rf_0_streamer_wack;
        rf_0_streamer_wt <= (rf_0_streamer_wt or (rf_0_streamer_wr and not rf_0_streamer_tr)) and not rf_0_streamer_wack;
        rf_0_streamer_rr <= (rf_0_streamer_rr or rf_0_streamer_re) and not rf_0_streamer_rack;
        rf_0_streamer_rt <= (rf_0_streamer_rt or (rf_0_streamer_rr and not (rf_0_streamer_wr or rf_0_streamer_tr))) and not rf_0_streamer_rack;
      end if;
    end if;
  end process;
  rf_0_streamer_o.cyc <= rf_0_streamer_tr;
  rf_0_streamer_o.stb <= rf_0_streamer_tr;
  rf_0_streamer_wack <= rf_0_streamer_i.ack and rf_0_streamer_wt;
  rf_0_streamer_rack <= rf_0_streamer_i.ack and rf_0_streamer_rt;
  process (rd_addr, wr_adr_d0, rf_0_streamer_wt) begin
    if rf_0_streamer_wt = '1' then
      rf_0_streamer_o.adr <= ((23 downto 0 => '0') & wr_adr_d0(7 downto 2)) & (1 downto 0 => '0');
    else
      rf_0_streamer_o.adr <= ((23 downto 0 => '0') & rd_addr(7 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    rf_0_streamer_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      rf_0_streamer_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      rf_0_streamer_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      rf_0_streamer_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      rf_0_streamer_o.sel(3) <= '1';
    end if;
  end process;
  rf_0_streamer_o.we <= rf_0_streamer_wt;
  rf_0_streamer_o.dat <= wr_dat_d0;

  -- Register rf_1_ftw_hi
  rf_1_ftw_hi_o <= rf_1_ftw_hi_reg;
  rf_1_ftw_hi_wack <= rf_1_ftw_hi_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_ftw_hi_reg <= "00000000000000000000000000000000";
      else
        if rf_1_ftw_hi_wreq = '1' then
          rf_1_ftw_hi_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_1_ftw_lo
  rf_1_ftw_lo_o <= rf_1_ftw_lo_reg;
  rf_1_ftw_lo_wack <= rf_1_ftw_lo_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_ftw_lo_reg <= "00000000000000000000000000000000";
      else
        if rf_1_ftw_lo_wreq = '1' then
          rf_1_ftw_lo_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_1_ftw_load
  rf_1_ftw_load_en_o <= wr_dat_d0(0);
  rf_1_ftw_load_reset_o <= wr_dat_d0(1);
  rf_1_ftw_load_rfframe_o <= wr_dat_d0(2);
  rf_1_ftw_load_wr_o <= rf_1_ftw_load_wreq;

  -- Register rf_1_bst_ctrl
  rf_1_bst_ctrl_en_o <= rf_1_bst_ctrl_en_reg;
  rf_1_bst_ctrl_wack <= rf_1_bst_ctrl_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_bst_ctrl_en_reg <= '0';
      else
        if rf_1_bst_ctrl_wreq = '1' then
          rf_1_bst_ctrl_en_reg <= wr_dat_d0(0);
        end if;
      end if;
    end if;
  end process;

  -- Register rf_1_h1
  rf_1_h1_o <= rf_1_h1_reg;
  rf_1_h1_wack <= rf_1_h1_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_h1_reg <= "00000000000000000000000000000000";
      else
        if rf_1_h1_wreq = '1' then
          rf_1_h1_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_1_gth_cfg
  rf_1_gth_cfg_o <= rf_1_gth_cfg_reg;
  rf_1_gth_cfg_wack <= rf_1_gth_cfg_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_gth_cfg_reg <= "00000000000000000000000000000000";
      else
        if rf_1_gth_cfg_wreq = '1' then
          rf_1_gth_cfg_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_1_gth_sta

  -- Register rf_1_rf_ftw

  -- Register rf_1_rf_ftw_lo

  -- Register rf_1_rf_rx_tai

  -- Register rf_1_rf_rx_cyc

  -- Register rf_1_rf_rx_sta
  rf_1_rf_rx_sta_wack <= rf_1_rf_rx_sta_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_rf_rx_sta_valid_reg <= '0';
      else
        if rf_1_rf_rx_sta_wreq = '1' then
          rf_1_rf_rx_sta_valid_reg <= rf_1_rf_rx_sta_valid_i or (rf_1_rf_rx_sta_valid_reg and not wr_dat_d0(0));
        else
          rf_1_rf_rx_sta_valid_reg <= rf_1_rf_rx_sta_valid_i or rf_1_rf_rx_sta_valid_reg;
        end if;
      end if;
    end if;
  end process;

  -- Interface rf_1_streamer
  rf_1_streamer_tr <= rf_1_streamer_wt or rf_1_streamer_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_1_streamer_rt <= '0';
        rf_1_streamer_wt <= '0';
        rf_1_streamer_wr <= '0';
        rf_1_streamer_rr <= '0';
      else
        rf_1_streamer_wr <= (rf_1_streamer_wr or rf_1_streamer_we) and not rf_1_streamer_wack;
        rf_1_streamer_wt <= (rf_1_streamer_wt or (rf_1_streamer_wr and not rf_1_streamer_tr)) and not rf_1_streamer_wack;
        rf_1_streamer_rr <= (rf_1_streamer_rr or rf_1_streamer_re) and not rf_1_streamer_rack;
        rf_1_streamer_rt <= (rf_1_streamer_rt or (rf_1_streamer_rr and not (rf_1_streamer_wr or rf_1_streamer_tr))) and not rf_1_streamer_rack;
      end if;
    end if;
  end process;
  rf_1_streamer_o.cyc <= rf_1_streamer_tr;
  rf_1_streamer_o.stb <= rf_1_streamer_tr;
  rf_1_streamer_wack <= rf_1_streamer_i.ack and rf_1_streamer_wt;
  rf_1_streamer_rack <= rf_1_streamer_i.ack and rf_1_streamer_rt;
  process (rd_addr, wr_adr_d0, rf_1_streamer_wt) begin
    if rf_1_streamer_wt = '1' then
      rf_1_streamer_o.adr <= ((23 downto 0 => '0') & wr_adr_d0(7 downto 2)) & (1 downto 0 => '0');
    else
      rf_1_streamer_o.adr <= ((23 downto 0 => '0') & rd_addr(7 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    rf_1_streamer_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      rf_1_streamer_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      rf_1_streamer_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      rf_1_streamer_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      rf_1_streamer_o.sel(3) <= '1';
    end if;
  end process;
  rf_1_streamer_o.we <= rf_1_streamer_wt;
  rf_1_streamer_o.dat <= wr_dat_d0;

  -- Register rf_2_ftw_hi
  rf_2_ftw_hi_o <= rf_2_ftw_hi_reg;
  rf_2_ftw_hi_wack <= rf_2_ftw_hi_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_ftw_hi_reg <= "00000000000000000000000000000000";
      else
        if rf_2_ftw_hi_wreq = '1' then
          rf_2_ftw_hi_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_2_ftw_lo
  rf_2_ftw_lo_o <= rf_2_ftw_lo_reg;
  rf_2_ftw_lo_wack <= rf_2_ftw_lo_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_ftw_lo_reg <= "00000000000000000000000000000000";
      else
        if rf_2_ftw_lo_wreq = '1' then
          rf_2_ftw_lo_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_2_ftw_load
  rf_2_ftw_load_en_o <= wr_dat_d0(0);
  rf_2_ftw_load_reset_o <= wr_dat_d0(1);
  rf_2_ftw_load_rfframe_o <= wr_dat_d0(2);
  rf_2_ftw_load_wr_o <= rf_2_ftw_load_wreq;

  -- Register rf_2_bst_ctrl
  rf_2_bst_ctrl_en_o <= rf_2_bst_ctrl_en_reg;
  rf_2_bst_ctrl_wack <= rf_2_bst_ctrl_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_bst_ctrl_en_reg <= '0';
      else
        if rf_2_bst_ctrl_wreq = '1' then
          rf_2_bst_ctrl_en_reg <= wr_dat_d0(0);
        end if;
      end if;
    end if;
  end process;

  -- Register rf_2_h1
  rf_2_h1_o <= rf_2_h1_reg;
  rf_2_h1_wack <= rf_2_h1_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_h1_reg <= "00000000000000000000000000000000";
      else
        if rf_2_h1_wreq = '1' then
          rf_2_h1_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_2_gth_cfg
  rf_2_gth_cfg_o <= rf_2_gth_cfg_reg;
  rf_2_gth_cfg_wack <= rf_2_gth_cfg_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_gth_cfg_reg <= "00000000000000000000000000000000";
      else
        if rf_2_gth_cfg_wreq = '1' then
          rf_2_gth_cfg_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register rf_2_gth_sta

  -- Register rf_2_rf_ftw

  -- Register rf_2_rf_ftw_lo

  -- Register rf_2_rf_rx_tai

  -- Register rf_2_rf_rx_cyc

  -- Register rf_2_rf_rx_sta
  rf_2_rf_rx_sta_wack <= rf_2_rf_rx_sta_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_rf_rx_sta_valid_reg <= '0';
      else
        if rf_2_rf_rx_sta_wreq = '1' then
          rf_2_rf_rx_sta_valid_reg <= rf_2_rf_rx_sta_valid_i or (rf_2_rf_rx_sta_valid_reg and not wr_dat_d0(0));
        else
          rf_2_rf_rx_sta_valid_reg <= rf_2_rf_rx_sta_valid_i or rf_2_rf_rx_sta_valid_reg;
        end if;
      end if;
    end if;
  end process;

  -- Interface rf_2_streamer
  rf_2_streamer_tr <= rf_2_streamer_wt or rf_2_streamer_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        rf_2_streamer_rt <= '0';
        rf_2_streamer_wt <= '0';
        rf_2_streamer_wr <= '0';
        rf_2_streamer_rr <= '0';
      else
        rf_2_streamer_wr <= (rf_2_streamer_wr or rf_2_streamer_we) and not rf_2_streamer_wack;
        rf_2_streamer_wt <= (rf_2_streamer_wt or (rf_2_streamer_wr and not rf_2_streamer_tr)) and not rf_2_streamer_wack;
        rf_2_streamer_rr <= (rf_2_streamer_rr or rf_2_streamer_re) and not rf_2_streamer_rack;
        rf_2_streamer_rt <= (rf_2_streamer_rt or (rf_2_streamer_rr and not (rf_2_streamer_wr or rf_2_streamer_tr))) and not rf_2_streamer_rack;
      end if;
    end if;
  end process;
  rf_2_streamer_o.cyc <= rf_2_streamer_tr;
  rf_2_streamer_o.stb <= rf_2_streamer_tr;
  rf_2_streamer_wack <= rf_2_streamer_i.ack and rf_2_streamer_wt;
  rf_2_streamer_rack <= rf_2_streamer_i.ack and rf_2_streamer_rt;
  process (rd_addr, wr_adr_d0, rf_2_streamer_wt) begin
    if rf_2_streamer_wt = '1' then
      rf_2_streamer_o.adr <= ((23 downto 0 => '0') & wr_adr_d0(7 downto 2)) & (1 downto 0 => '0');
    else
      rf_2_streamer_o.adr <= ((23 downto 0 => '0') & rd_addr(7 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    rf_2_streamer_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      rf_2_streamer_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      rf_2_streamer_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      rf_2_streamer_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      rf_2_streamer_o.sel(3) <= '1';
    end if;
  end process;
  rf_2_streamer_o.we <= rf_2_streamer_wt;
  rf_2_streamer_o.dat <= wr_dat_d0;

  -- Register inputs_summary

  -- Register inputs_csr_0_en
  inputs_csr_0_en_o <= inputs_csr_0_en_reg;
  inputs_csr_0_en_wack <= inputs_csr_0_en_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        inputs_csr_0_en_reg <= "00000000000000000000000000000000";
      else
        if inputs_csr_0_en_wreq = '1' then
          inputs_csr_0_en_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register inputs_csr_0_rise_sr
  inputs_csr_0_rise_sr_o <= wr_dat_d0;
  inputs_csr_0_rise_sr_wr_o <= inputs_csr_0_rise_sr_wreq;

  -- Register inputs_csr_0_fall_sr

  -- Register inputs_csr_1_en
  inputs_csr_1_en_o <= inputs_csr_1_en_reg;
  inputs_csr_1_en_wack <= inputs_csr_1_en_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        inputs_csr_1_en_reg <= "00000000000000000000000000000000";
      else
        if inputs_csr_1_en_wreq = '1' then
          inputs_csr_1_en_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register inputs_csr_1_rise_sr
  inputs_csr_1_rise_sr_o <= wr_dat_d0;
  inputs_csr_1_rise_sr_wr_o <= inputs_csr_1_rise_sr_wreq;

  -- Register inputs_csr_1_fall_sr

  -- Register inputs_csr_2_en
  inputs_csr_2_en_o <= inputs_csr_2_en_reg;
  inputs_csr_2_en_wack <= inputs_csr_2_en_wreq;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        inputs_csr_2_en_reg <= "00000000000000000000000000000000";
      else
        if inputs_csr_2_en_wreq = '1' then
          inputs_csr_2_en_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register inputs_csr_2_rise_sr
  inputs_csr_2_rise_sr_o <= wr_dat_d0;
  inputs_csr_2_rise_sr_wr_o <= inputs_csr_2_rise_sr_wreq;

  -- Register inputs_csr_2_fall_sr

  -- Interface inputs_ts
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        inputs_ts_rack <= '0';
      else
        inputs_ts_rack <= inputs_ts_re and not inputs_ts_rack;
      end if;
    end if;
  end process;
  inputs_ts_addr_o <= rd_addr(10 downto 2);

  -- Interface pulser_group_0_el
  pulser_group_0_el_tr <= pulser_group_0_el_wt or pulser_group_0_el_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulser_group_0_el_rt <= '0';
        pulser_group_0_el_wt <= '0';
        pulser_group_0_el_wr <= '0';
        pulser_group_0_el_rr <= '0';
      else
        pulser_group_0_el_wr <= (pulser_group_0_el_wr or pulser_group_0_el_we) and not pulser_group_0_el_wack;
        pulser_group_0_el_wt <= (pulser_group_0_el_wt or (pulser_group_0_el_wr and not pulser_group_0_el_tr)) and not pulser_group_0_el_wack;
        pulser_group_0_el_rr <= (pulser_group_0_el_rr or pulser_group_0_el_re) and not pulser_group_0_el_rack;
        pulser_group_0_el_rt <= (pulser_group_0_el_rt or (pulser_group_0_el_rr and not (pulser_group_0_el_wr or pulser_group_0_el_tr))) and not pulser_group_0_el_rack;
      end if;
    end if;
  end process;
  pulser_group_0_el_o.cyc <= pulser_group_0_el_tr;
  pulser_group_0_el_o.stb <= pulser_group_0_el_tr;
  pulser_group_0_el_wack <= pulser_group_0_el_i.ack and pulser_group_0_el_wt;
  pulser_group_0_el_rack <= pulser_group_0_el_i.ack and pulser_group_0_el_rt;
  process (rd_addr, wr_adr_d0, pulser_group_0_el_wt) begin
    if pulser_group_0_el_wt = '1' then
      pulser_group_0_el_o.adr <= ((19 downto 0 => '0') & wr_adr_d0(11 downto 2)) & (1 downto 0 => '0');
    else
      pulser_group_0_el_o.adr <= ((19 downto 0 => '0') & rd_addr(11 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    pulser_group_0_el_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      pulser_group_0_el_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      pulser_group_0_el_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      pulser_group_0_el_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      pulser_group_0_el_o.sel(3) <= '1';
    end if;
  end process;
  pulser_group_0_el_o.we <= pulser_group_0_el_wt;
  pulser_group_0_el_o.dat <= wr_dat_d0;

  -- Interface pulser_group_1_el
  pulser_group_1_el_tr <= pulser_group_1_el_wt or pulser_group_1_el_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulser_group_1_el_rt <= '0';
        pulser_group_1_el_wt <= '0';
        pulser_group_1_el_wr <= '0';
        pulser_group_1_el_rr <= '0';
      else
        pulser_group_1_el_wr <= (pulser_group_1_el_wr or pulser_group_1_el_we) and not pulser_group_1_el_wack;
        pulser_group_1_el_wt <= (pulser_group_1_el_wt or (pulser_group_1_el_wr and not pulser_group_1_el_tr)) and not pulser_group_1_el_wack;
        pulser_group_1_el_rr <= (pulser_group_1_el_rr or pulser_group_1_el_re) and not pulser_group_1_el_rack;
        pulser_group_1_el_rt <= (pulser_group_1_el_rt or (pulser_group_1_el_rr and not (pulser_group_1_el_wr or pulser_group_1_el_tr))) and not pulser_group_1_el_rack;
      end if;
    end if;
  end process;
  pulser_group_1_el_o.cyc <= pulser_group_1_el_tr;
  pulser_group_1_el_o.stb <= pulser_group_1_el_tr;
  pulser_group_1_el_wack <= pulser_group_1_el_i.ack and pulser_group_1_el_wt;
  pulser_group_1_el_rack <= pulser_group_1_el_i.ack and pulser_group_1_el_rt;
  process (rd_addr, wr_adr_d0, pulser_group_1_el_wt) begin
    if pulser_group_1_el_wt = '1' then
      pulser_group_1_el_o.adr <= ((19 downto 0 => '0') & wr_adr_d0(11 downto 2)) & (1 downto 0 => '0');
    else
      pulser_group_1_el_o.adr <= ((19 downto 0 => '0') & rd_addr(11 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    pulser_group_1_el_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      pulser_group_1_el_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      pulser_group_1_el_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      pulser_group_1_el_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      pulser_group_1_el_o.sel(3) <= '1';
    end if;
  end process;
  pulser_group_1_el_o.we <= pulser_group_1_el_wt;
  pulser_group_1_el_o.dat <= wr_dat_d0;

  -- Interface pulser_group_2_el
  pulser_group_2_el_tr <= pulser_group_2_el_wt or pulser_group_2_el_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulser_group_2_el_rt <= '0';
        pulser_group_2_el_wt <= '0';
        pulser_group_2_el_wr <= '0';
        pulser_group_2_el_rr <= '0';
      else
        pulser_group_2_el_wr <= (pulser_group_2_el_wr or pulser_group_2_el_we) and not pulser_group_2_el_wack;
        pulser_group_2_el_wt <= (pulser_group_2_el_wt or (pulser_group_2_el_wr and not pulser_group_2_el_tr)) and not pulser_group_2_el_wack;
        pulser_group_2_el_rr <= (pulser_group_2_el_rr or pulser_group_2_el_re) and not pulser_group_2_el_rack;
        pulser_group_2_el_rt <= (pulser_group_2_el_rt or (pulser_group_2_el_rr and not (pulser_group_2_el_wr or pulser_group_2_el_tr))) and not pulser_group_2_el_rack;
      end if;
    end if;
  end process;
  pulser_group_2_el_o.cyc <= pulser_group_2_el_tr;
  pulser_group_2_el_o.stb <= pulser_group_2_el_tr;
  pulser_group_2_el_wack <= pulser_group_2_el_i.ack and pulser_group_2_el_wt;
  pulser_group_2_el_rack <= pulser_group_2_el_i.ack and pulser_group_2_el_rt;
  process (rd_addr, wr_adr_d0, pulser_group_2_el_wt) begin
    if pulser_group_2_el_wt = '1' then
      pulser_group_2_el_o.adr <= ((19 downto 0 => '0') & wr_adr_d0(11 downto 2)) & (1 downto 0 => '0');
    else
      pulser_group_2_el_o.adr <= ((19 downto 0 => '0') & rd_addr(11 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    pulser_group_2_el_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      pulser_group_2_el_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      pulser_group_2_el_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      pulser_group_2_el_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      pulser_group_2_el_o.sel(3) <= '1';
    end if;
  end process;
  pulser_group_2_el_o.we <= pulser_group_2_el_wt;
  pulser_group_2_el_o.dat <= wr_dat_d0;

  -- Interface pulser_group_3_el
  pulser_group_3_el_tr <= pulser_group_3_el_wt or pulser_group_3_el_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        pulser_group_3_el_rt <= '0';
        pulser_group_3_el_wt <= '0';
        pulser_group_3_el_wr <= '0';
        pulser_group_3_el_rr <= '0';
      else
        pulser_group_3_el_wr <= (pulser_group_3_el_wr or pulser_group_3_el_we) and not pulser_group_3_el_wack;
        pulser_group_3_el_wt <= (pulser_group_3_el_wt or (pulser_group_3_el_wr and not pulser_group_3_el_tr)) and not pulser_group_3_el_wack;
        pulser_group_3_el_rr <= (pulser_group_3_el_rr or pulser_group_3_el_re) and not pulser_group_3_el_rack;
        pulser_group_3_el_rt <= (pulser_group_3_el_rt or (pulser_group_3_el_rr and not (pulser_group_3_el_wr or pulser_group_3_el_tr))) and not pulser_group_3_el_rack;
      end if;
    end if;
  end process;
  pulser_group_3_el_o.cyc <= pulser_group_3_el_tr;
  pulser_group_3_el_o.stb <= pulser_group_3_el_tr;
  pulser_group_3_el_wack <= pulser_group_3_el_i.ack and pulser_group_3_el_wt;
  pulser_group_3_el_rack <= pulser_group_3_el_i.ack and pulser_group_3_el_rt;
  process (rd_addr, wr_adr_d0, pulser_group_3_el_wt) begin
    if pulser_group_3_el_wt = '1' then
      pulser_group_3_el_o.adr <= ((19 downto 0 => '0') & wr_adr_d0(11 downto 2)) & (1 downto 0 => '0');
    else
      pulser_group_3_el_o.adr <= ((19 downto 0 => '0') & rd_addr(11 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    pulser_group_3_el_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      pulser_group_3_el_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      pulser_group_3_el_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      pulser_group_3_el_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      pulser_group_3_el_o.sel(3) <= '1';
    end if;
  end process;
  pulser_group_3_el_o.we <= pulser_group_3_el_wt;
  pulser_group_3_el_o.dat <= wr_dat_d0;

  -- Interface wrnic
  wrnic_tr <= wrnic_wt or wrnic_rt;
  process (aclk) begin
    if rising_edge(aclk) then
      if areset_n = '0' then
        wrnic_rt <= '0';
        wrnic_wt <= '0';
        wrnic_wr <= '0';
        wrnic_rr <= '0';
      else
        wrnic_wr <= (wrnic_wr or wrnic_we) and not wrnic_wack;
        wrnic_wt <= (wrnic_wt or (wrnic_wr and not wrnic_tr)) and not wrnic_wack;
        wrnic_rr <= (wrnic_rr or wrnic_re) and not wrnic_rack;
        wrnic_rt <= (wrnic_rt or (wrnic_rr and not (wrnic_wr or wrnic_tr))) and not wrnic_rack;
      end if;
    end if;
  end process;
  wrnic_o.cyc <= wrnic_tr;
  wrnic_o.stb <= wrnic_tr;
  wrnic_wack <= wrnic_i.ack and wrnic_wt;
  wrnic_rack <= wrnic_i.ack and wrnic_rt;
  process (rd_addr, wr_adr_d0, wrnic_wt) begin
    if wrnic_wt = '1' then
      wrnic_o.adr <= ((15 downto 0 => '0') & wr_adr_d0(15 downto 2)) & (1 downto 0 => '0');
    else
      wrnic_o.adr <= ((15 downto 0 => '0') & rd_addr(15 downto 2)) & (1 downto 0 => '0');
    end if;
  end process;
  process (wr_sel_d0) begin
    wrnic_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      wrnic_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      wrnic_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      wrnic_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      wrnic_o.sel(3) <= '1';
    end if;
  end process;
  wrnic_o.we <= wrnic_wt;
  wrnic_o.dat <= wr_dat_d0;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, fw_version_wack, fp_term_wack, fp_inv_wack,
           fp_oe_wack, userio_inv_wack, userio_cfg_wack, pulsers_raw_wack,
           pulsers_int_wack, pulsers_mask_wack, pxie_dstarc_wack,
           pxie_dstara_wack, si5340_wack, leds_force_wack, leds_rgb_out_hi_wack,
           leds_rgb_out_lo_wack, leds_rgb_in_hi_wack, leds_rgb_in_lo_wack,
           leds_colors_ws, leds_colors_wack_i, rf_0_ftw_hi_wack,
           rf_0_ftw_lo_wack, rf_0_bst_ctrl_wack, rf_0_h1_wack, rf_0_gth_cfg_wack,
           rf_0_rf_rx_sta_wack, rf_0_streamer_wack, rf_1_ftw_hi_wack,
           rf_1_ftw_lo_wack, rf_1_bst_ctrl_wack, rf_1_h1_wack, rf_1_gth_cfg_wack,
           rf_1_rf_rx_sta_wack, rf_1_streamer_wack, rf_2_ftw_hi_wack,
           rf_2_ftw_lo_wack, rf_2_bst_ctrl_wack, rf_2_h1_wack, rf_2_gth_cfg_wack,
           rf_2_rf_rx_sta_wack, rf_2_streamer_wack, inputs_csr_0_en_wack,
           inputs_csr_1_en_wack, inputs_csr_2_en_wack, pulser_group_0_el_wack,
           pulser_group_1_el_wack, pulser_group_2_el_wack,
           pulser_group_3_el_wack, wrnic_wack) begin
    fw_version_wreq <= '0';
    ifr_wreq <= '0';
    fp_term_wreq <= '0';
    fp_inv_wreq <= '0';
    fp_oe_wreq <= '0';
    userio_inv_wreq <= '0';
    userio_cfg_wreq <= '0';
    pulsers_raw_wreq <= '0';
    pulsers_int_wreq <= '0';
    pulsers_mask_wreq <= '0';
    pxie_dstarc_wreq <= '0';
    pxie_dstara_wreq <= '0';
    si5340_we <= '0';
    leds_force_wreq <= '0';
    leds_rgb_out_hi_wreq <= '0';
    leds_rgb_out_lo_wreq <= '0';
    leds_rgb_in_hi_wreq <= '0';
    leds_rgb_in_lo_wreq <= '0';
    leds_colors_we <= '0';
    leds_colors_wr_o <= '0';
    rf_0_ftw_hi_wreq <= '0';
    rf_0_ftw_lo_wreq <= '0';
    rf_0_ftw_load_wreq <= '0';
    rf_0_bst_ctrl_wreq <= '0';
    rf_0_h1_wreq <= '0';
    rf_0_gth_cfg_wreq <= '0';
    rf_0_rf_rx_sta_wreq <= '0';
    rf_0_streamer_we <= '0';
    rf_1_ftw_hi_wreq <= '0';
    rf_1_ftw_lo_wreq <= '0';
    rf_1_ftw_load_wreq <= '0';
    rf_1_bst_ctrl_wreq <= '0';
    rf_1_h1_wreq <= '0';
    rf_1_gth_cfg_wreq <= '0';
    rf_1_rf_rx_sta_wreq <= '0';
    rf_1_streamer_we <= '0';
    rf_2_ftw_hi_wreq <= '0';
    rf_2_ftw_lo_wreq <= '0';
    rf_2_ftw_load_wreq <= '0';
    rf_2_bst_ctrl_wreq <= '0';
    rf_2_h1_wreq <= '0';
    rf_2_gth_cfg_wreq <= '0';
    rf_2_rf_rx_sta_wreq <= '0';
    rf_2_streamer_we <= '0';
    inputs_csr_0_en_wreq <= '0';
    inputs_csr_0_rise_sr_wreq <= '0';
    inputs_csr_1_en_wreq <= '0';
    inputs_csr_1_rise_sr_wreq <= '0';
    inputs_csr_2_en_wreq <= '0';
    inputs_csr_2_rise_sr_wreq <= '0';
    pulser_group_0_el_we <= '0';
    pulser_group_1_el_we <= '0';
    pulser_group_2_el_we <= '0';
    pulser_group_3_el_we <= '0';
    wrnic_we <= '0';
    case wr_adr_d0(16 downto 16) is
    when "0" =>
      case wr_adr_d0(15 downto 12) is
      when "0000" =>
        case wr_adr_d0(11 downto 8) is
        when "0000" =>
          case wr_adr_d0(7 downto 2) is
          when "000000" =>
            -- Reg map_version
            wr_ack <= wr_req_d0;
          when "000001" =>
            -- Reg model_id
            wr_ack <= wr_req_d0;
          when "000010" =>
            -- Reg fw_version
            fw_version_wreq <= wr_req_d0;
            wr_ack <= fw_version_wack;
          when "000011" =>
            -- Reg wr_state
            wr_ack <= wr_req_d0;
          when "000100" =>
            -- Reg tm_tai_lo
            wr_ack <= wr_req_d0;
          when "000101" =>
            -- Reg tm_tai_hi
            wr_ack <= wr_req_d0;
          when "000110" =>
            -- Reg tm_cycles
            wr_ack <= wr_req_d0;
          when "000111" =>
            -- Reg ifr
            ifr_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "001000" =>
            -- Reg fp_term
            fp_term_wreq <= wr_req_d0;
            wr_ack <= fp_term_wack;
          when "001001" =>
            -- Reg fp_inv
            fp_inv_wreq <= wr_req_d0;
            wr_ack <= fp_inv_wack;
          when "001010" =>
            -- Reg fp_oe
            fp_oe_wreq <= wr_req_d0;
            wr_ack <= fp_oe_wack;
          when "001011" =>
            -- Reg userio_inv
            userio_inv_wreq <= wr_req_d0;
            wr_ack <= userio_inv_wack;
          when "001100" =>
            -- Reg userio_in
            wr_ack <= wr_req_d0;
          when "001101" =>
            -- Reg userio_cfg
            userio_cfg_wreq <= wr_req_d0;
            wr_ack <= userio_cfg_wack;
          when "001110" =>
            -- Reg pulsers_raw
            pulsers_raw_wreq <= wr_req_d0;
            wr_ack <= pulsers_raw_wack;
          when "001111" =>
            -- Reg pulsers_int
            pulsers_int_wreq <= wr_req_d0;
            wr_ack <= pulsers_int_wack;
          when "010000" =>
            -- Reg pulsers_mask
            pulsers_mask_wreq <= wr_req_d0;
            wr_ack <= pulsers_mask_wack;
          when "010001" =>
            -- Reg board_id
            wr_ack <= wr_req_d0;
          when "010010" =>
            -- Reg pxie_dstarc
            pxie_dstarc_wreq <= wr_req_d0;
            wr_ack <= pxie_dstarc_wack;
          when "010011" =>
            -- Reg pxie_dstara
            pxie_dstara_wreq <= wr_req_d0;
            wr_ack <= pxie_dstara_wack;
          when "010100" =>
            -- Reg nic_fifo
            wr_ack <= wr_req_d0;
          when others =>
            wr_ack <= wr_req_d0;
          end case;
        when "1101" =>
          -- Submap si5340
          si5340_we <= wr_req_d0;
          wr_ack <= si5340_wack;
        when "1110" =>
          case wr_adr_d0(7 downto 2) is
          when "000000" =>
            -- Reg leds_force
            leds_force_wreq <= wr_req_d0;
            wr_ack <= leds_force_wack;
          when "000001" =>
            -- Reg leds_rgb_out_hi
            leds_rgb_out_hi_wreq <= wr_req_d0;
            wr_ack <= leds_rgb_out_hi_wack;
          when "000010" =>
            -- Reg leds_rgb_out_lo
            leds_rgb_out_lo_wreq <= wr_req_d0;
            wr_ack <= leds_rgb_out_lo_wack;
          when "000011" =>
            -- Reg leds_rgb_in_hi
            leds_rgb_in_hi_wreq <= wr_req_d0;
            wr_ack <= leds_rgb_in_hi_wack;
          when "000100" =>
            -- Reg leds_rgb_in_lo
            leds_rgb_in_lo_wreq <= wr_req_d0;
            wr_ack <= leds_rgb_in_lo_wack;
          when others =>
            wr_ack <= wr_req_d0;
          end case;
        when "1111" =>
          -- Memory leds_colors
          leds_colors_we <= wr_req_d0;
          leds_colors_wr_o <= leds_colors_ws;
          wr_ack <= leds_colors_wack_i;
        when others =>
          wr_ack <= wr_req_d0;
        end case;
      when "0001" =>
        case wr_adr_d0(11 downto 8) is
        when "0000" =>
          case wr_adr_d0(7 downto 2) is
          when "000000" =>
            -- Reg rf_0_ftw_hi
            rf_0_ftw_hi_wreq <= wr_req_d0;
            wr_ack <= rf_0_ftw_hi_wack;
          when "000001" =>
            -- Reg rf_0_ftw_lo
            rf_0_ftw_lo_wreq <= wr_req_d0;
            wr_ack <= rf_0_ftw_lo_wack;
          when "000010" =>
            -- Reg rf_0_ftw_load
            rf_0_ftw_load_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "000011" =>
            -- Reg rf_0_bst_ctrl
            rf_0_bst_ctrl_wreq <= wr_req_d0;
            wr_ack <= rf_0_bst_ctrl_wack;
          when "000100" =>
            -- Reg rf_0_h1
            rf_0_h1_wreq <= wr_req_d0;
            wr_ack <= rf_0_h1_wack;
          when "000101" =>
            -- Reg rf_0_gth_cfg
            rf_0_gth_cfg_wreq <= wr_req_d0;
            wr_ack <= rf_0_gth_cfg_wack;
          when "000110" =>
            -- Reg rf_0_gth_sta
            wr_ack <= wr_req_d0;
          when "000111" =>
            -- Reg rf_0_rf_ftw
            wr_ack <= wr_req_d0;
          when "001000" =>
            -- Reg rf_0_rf_ftw_lo
            wr_ack <= wr_req_d0;
          when "001001" =>
            -- Reg rf_0_rf_rx_tai
            wr_ack <= wr_req_d0;
          when "001010" =>
            -- Reg rf_0_rf_rx_cyc
            wr_ack <= wr_req_d0;
          when "001011" =>
            -- Reg rf_0_rf_rx_sta
            rf_0_rf_rx_sta_wreq <= wr_req_d0;
            wr_ack <= rf_0_rf_rx_sta_wack;
          when others =>
            wr_ack <= wr_req_d0;
          end case;
        when "0001" =>
          -- Submap rf_0_streamer
          rf_0_streamer_we <= wr_req_d0;
          wr_ack <= rf_0_streamer_wack;
        when "0010" =>
          case wr_adr_d0(7 downto 2) is
          when "000000" =>
            -- Reg rf_1_ftw_hi
            rf_1_ftw_hi_wreq <= wr_req_d0;
            wr_ack <= rf_1_ftw_hi_wack;
          when "000001" =>
            -- Reg rf_1_ftw_lo
            rf_1_ftw_lo_wreq <= wr_req_d0;
            wr_ack <= rf_1_ftw_lo_wack;
          when "000010" =>
            -- Reg rf_1_ftw_load
            rf_1_ftw_load_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "000011" =>
            -- Reg rf_1_bst_ctrl
            rf_1_bst_ctrl_wreq <= wr_req_d0;
            wr_ack <= rf_1_bst_ctrl_wack;
          when "000100" =>
            -- Reg rf_1_h1
            rf_1_h1_wreq <= wr_req_d0;
            wr_ack <= rf_1_h1_wack;
          when "000101" =>
            -- Reg rf_1_gth_cfg
            rf_1_gth_cfg_wreq <= wr_req_d0;
            wr_ack <= rf_1_gth_cfg_wack;
          when "000110" =>
            -- Reg rf_1_gth_sta
            wr_ack <= wr_req_d0;
          when "000111" =>
            -- Reg rf_1_rf_ftw
            wr_ack <= wr_req_d0;
          when "001000" =>
            -- Reg rf_1_rf_ftw_lo
            wr_ack <= wr_req_d0;
          when "001001" =>
            -- Reg rf_1_rf_rx_tai
            wr_ack <= wr_req_d0;
          when "001010" =>
            -- Reg rf_1_rf_rx_cyc
            wr_ack <= wr_req_d0;
          when "001011" =>
            -- Reg rf_1_rf_rx_sta
            rf_1_rf_rx_sta_wreq <= wr_req_d0;
            wr_ack <= rf_1_rf_rx_sta_wack;
          when others =>
            wr_ack <= wr_req_d0;
          end case;
        when "0011" =>
          -- Submap rf_1_streamer
          rf_1_streamer_we <= wr_req_d0;
          wr_ack <= rf_1_streamer_wack;
        when "0100" =>
          case wr_adr_d0(7 downto 2) is
          when "000000" =>
            -- Reg rf_2_ftw_hi
            rf_2_ftw_hi_wreq <= wr_req_d0;
            wr_ack <= rf_2_ftw_hi_wack;
          when "000001" =>
            -- Reg rf_2_ftw_lo
            rf_2_ftw_lo_wreq <= wr_req_d0;
            wr_ack <= rf_2_ftw_lo_wack;
          when "000010" =>
            -- Reg rf_2_ftw_load
            rf_2_ftw_load_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "000011" =>
            -- Reg rf_2_bst_ctrl
            rf_2_bst_ctrl_wreq <= wr_req_d0;
            wr_ack <= rf_2_bst_ctrl_wack;
          when "000100" =>
            -- Reg rf_2_h1
            rf_2_h1_wreq <= wr_req_d0;
            wr_ack <= rf_2_h1_wack;
          when "000101" =>
            -- Reg rf_2_gth_cfg
            rf_2_gth_cfg_wreq <= wr_req_d0;
            wr_ack <= rf_2_gth_cfg_wack;
          when "000110" =>
            -- Reg rf_2_gth_sta
            wr_ack <= wr_req_d0;
          when "000111" =>
            -- Reg rf_2_rf_ftw
            wr_ack <= wr_req_d0;
          when "001000" =>
            -- Reg rf_2_rf_ftw_lo
            wr_ack <= wr_req_d0;
          when "001001" =>
            -- Reg rf_2_rf_rx_tai
            wr_ack <= wr_req_d0;
          when "001010" =>
            -- Reg rf_2_rf_rx_cyc
            wr_ack <= wr_req_d0;
          when "001011" =>
            -- Reg rf_2_rf_rx_sta
            rf_2_rf_rx_sta_wreq <= wr_req_d0;
            wr_ack <= rf_2_rf_rx_sta_wack;
          when others =>
            wr_ack <= wr_req_d0;
          end case;
        when "0101" =>
          -- Submap rf_2_streamer
          rf_2_streamer_we <= wr_req_d0;
          wr_ack <= rf_2_streamer_wack;
        when others =>
          wr_ack <= wr_req_d0;
        end case;
      when "0010" =>
        case wr_adr_d0(11 downto 11) is
        when "0" =>
          case wr_adr_d0(10 downto 2) is
          when "000000000" =>
            -- Reg inputs_summary
            wr_ack <= wr_req_d0;
          when "000010000" =>
            -- Reg inputs_csr_0_en
            inputs_csr_0_en_wreq <= wr_req_d0;
            wr_ack <= inputs_csr_0_en_wack;
          when "000010001" =>
            -- Reg inputs_csr_0_rise_sr
            inputs_csr_0_rise_sr_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "000010010" =>
            -- Reg inputs_csr_0_fall_sr
            wr_ack <= wr_req_d0;
          when "000010011" =>
            -- Reg inputs_csr_1_en
            inputs_csr_1_en_wreq <= wr_req_d0;
            wr_ack <= inputs_csr_1_en_wack;
          when "000010100" =>
            -- Reg inputs_csr_1_rise_sr
            inputs_csr_1_rise_sr_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "000010101" =>
            -- Reg inputs_csr_1_fall_sr
            wr_ack <= wr_req_d0;
          when "000010110" =>
            -- Reg inputs_csr_2_en
            inputs_csr_2_en_wreq <= wr_req_d0;
            wr_ack <= inputs_csr_2_en_wack;
          when "000010111" =>
            -- Reg inputs_csr_2_rise_sr
            inputs_csr_2_rise_sr_wreq <= wr_req_d0;
            wr_ack <= wr_req_d0;
          when "000011000" =>
            -- Reg inputs_csr_2_fall_sr
            wr_ack <= wr_req_d0;
          when others =>
            wr_ack <= wr_req_d0;
          end case;
        when "1" =>
          -- Memory inputs_ts
          wr_ack <= wr_req_d0;
        when others =>
          wr_ack <= wr_req_d0;
        end case;
      when "1000" =>
        -- Submap pulser_group_0_el
        pulser_group_0_el_we <= wr_req_d0;
        wr_ack <= pulser_group_0_el_wack;
      when "1001" =>
        -- Submap pulser_group_1_el
        pulser_group_1_el_we <= wr_req_d0;
        wr_ack <= pulser_group_1_el_wack;
      when "1010" =>
        -- Submap pulser_group_2_el
        pulser_group_2_el_we <= wr_req_d0;
        wr_ack <= pulser_group_2_el_wack;
      when "1011" =>
        -- Submap pulser_group_3_el
        pulser_group_3_el_we <= wr_req_d0;
        wr_ack <= pulser_group_3_el_wack;
      when others =>
        wr_ack <= wr_req_d0;
      end case;
    when "1" =>
      -- Submap wrnic
      wrnic_we <= wr_req_d0;
      wr_ack <= wrnic_wack;
    when others =>
      wr_ack <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (rd_addr, rd_req, map_version_i, model_id_i, fw_version_reg,
           wr_state_link_up_i, wr_state_time_valid_i, tm_tai_lo_i, tm_tai_hi_i,
           tm_cycles_i, fp_term_reg, fp_inv_reg, fp_oe_reg, userio_inv_reg,
           userio_in_i, userio_cfg_dir_reg, userio_cfg_en_reg,
           userio_cfg_pp_en_reg, pulsers_raw_reg, pulsers_int_reg,
           pulsers_mask_reg, board_id_switches_i, board_id_fp_id_i,
           board_id_pp_id_i, board_id_vme_ga_i, pxie_dstarc_mux_reg,
           pxie_dstara_mux_reg, nic_fifo_max_count_i, nic_fifo_full_i,
           si5340_i.dat, si5340_rack, leds_force_reg, leds_rgb_out_hi_reg,
           leds_rgb_out_lo_reg, leds_rgb_in_hi_reg, leds_rgb_in_lo_reg,
           leds_colors_rs, leds_colors_dato_i, leds_colors_rack_i,
           rf_0_ftw_hi_reg, rf_0_ftw_lo_reg, rf_0_bst_ctrl_en_reg, rf_0_h1_reg,
           rf_0_gth_cfg_reg, rf_0_gth_sta_i, rf_0_rf_ftw_hi_i, rf_0_rf_ftw_rst_i,
           rf_0_rf_ftw_lo_i, rf_0_rf_rx_tai_i, rf_0_rf_rx_cyc_i,
           rf_0_rf_rx_sta_valid_reg, rf_0_streamer_i.dat, rf_0_streamer_rack,
           rf_1_ftw_hi_reg, rf_1_ftw_lo_reg, rf_1_bst_ctrl_en_reg, rf_1_h1_reg,
           rf_1_gth_cfg_reg, rf_1_gth_sta_i, rf_1_rf_ftw_hi_i, rf_1_rf_ftw_rst_i,
           rf_1_rf_ftw_lo_i, rf_1_rf_rx_tai_i, rf_1_rf_rx_cyc_i,
           rf_1_rf_rx_sta_valid_reg, rf_1_streamer_i.dat, rf_1_streamer_rack,
           rf_2_ftw_hi_reg, rf_2_ftw_lo_reg, rf_2_bst_ctrl_en_reg, rf_2_h1_reg,
           rf_2_gth_cfg_reg, rf_2_gth_sta_i, rf_2_rf_ftw_hi_i, rf_2_rf_ftw_rst_i,
           rf_2_rf_ftw_lo_i, rf_2_rf_rx_tai_i, rf_2_rf_rx_cyc_i,
           rf_2_rf_rx_sta_valid_reg, rf_2_streamer_i.dat, rf_2_streamer_rack,
           inputs_summary_rise_i, inputs_summary_fall_i, inputs_csr_0_en_reg,
           inputs_csr_0_rise_sr_i, inputs_csr_0_fall_sr_i, inputs_csr_1_en_reg,
           inputs_csr_1_rise_sr_i, inputs_csr_1_fall_sr_i, inputs_csr_2_en_reg,
           inputs_csr_2_rise_sr_i, inputs_csr_2_fall_sr_i, inputs_ts_data_i,
           inputs_ts_rack, pulser_group_0_el_i.dat, pulser_group_0_el_rack,
           pulser_group_1_el_i.dat, pulser_group_1_el_rack,
           pulser_group_2_el_i.dat, pulser_group_2_el_rack,
           pulser_group_3_el_i.dat, pulser_group_3_el_rack, wrnic_i.dat,
           wrnic_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    si5340_re <= '0';
    leds_colors_rd_o <= '0';
    leds_colors_re <= '0';
    rf_0_streamer_re <= '0';
    rf_1_streamer_re <= '0';
    rf_2_streamer_re <= '0';
    inputs_ts_re <= '0';
    pulser_group_0_el_re <= '0';
    pulser_group_1_el_re <= '0';
    pulser_group_2_el_re <= '0';
    pulser_group_3_el_re <= '0';
    wrnic_re <= '0';
    case rd_addr(16 downto 16) is
    when "0" =>
      case rd_addr(15 downto 12) is
      when "0000" =>
        case rd_addr(11 downto 8) is
        when "0000" =>
          case rd_addr(7 downto 2) is
          when "000000" =>
            -- Reg map_version
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= map_version_i;
          when "000001" =>
            -- Reg model_id
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= model_id_i;
          when "000010" =>
            -- Reg fw_version
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= fw_version_reg;
          when "000011" =>
            -- Reg wr_state
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= wr_state_link_up_i;
            rd_dat_d0(1) <= wr_state_time_valid_i;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when "000100" =>
            -- Reg tm_tai_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= tm_tai_lo_i;
          when "000101" =>
            -- Reg tm_tai_hi
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= tm_tai_hi_i;
          when "000110" =>
            -- Reg tm_cycles
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= tm_cycles_i;
          when "000111" =>
            -- Reg ifr
            rd_ack_d0 <= rd_req;
          when "001000" =>
            -- Reg fp_term
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= fp_term_reg;
          when "001001" =>
            -- Reg fp_inv
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= fp_inv_reg;
          when "001010" =>
            -- Reg fp_oe
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= fp_oe_reg;
          when "001011" =>
            -- Reg userio_inv
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= userio_inv_reg;
          when "001100" =>
            -- Reg userio_in
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= userio_in_i;
          when "001101" =>
            -- Reg userio_cfg
            rd_ack_d0 <= rd_req;
            rd_dat_d0(3 downto 0) <= userio_cfg_dir_reg;
            rd_dat_d0(7 downto 4) <= userio_cfg_en_reg;
            rd_dat_d0(8) <= userio_cfg_pp_en_reg;
            rd_dat_d0(31 downto 9) <= (others => '0');
          when "001110" =>
            -- Reg pulsers_raw
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= pulsers_raw_reg;
          when "001111" =>
            -- Reg pulsers_int
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= pulsers_int_reg;
          when "010000" =>
            -- Reg pulsers_mask
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= pulsers_mask_reg;
          when "010001" =>
            -- Reg board_id
            rd_ack_d0 <= rd_req;
            rd_dat_d0(7 downto 0) <= board_id_switches_i;
            rd_dat_d0(10 downto 8) <= board_id_fp_id_i;
            rd_dat_d0(11) <= '0';
            rd_dat_d0(14 downto 12) <= board_id_pp_id_i;
            rd_dat_d0(15) <= '0';
            rd_dat_d0(21 downto 16) <= board_id_vme_ga_i;
            rd_dat_d0(31 downto 22) <= (others => '0');
          when "010010" =>
            -- Reg pxie_dstarc
            rd_ack_d0 <= rd_req;
            rd_dat_d0(7 downto 0) <= pxie_dstarc_mux_reg;
            rd_dat_d0(31 downto 8) <= (others => '0');
          when "010011" =>
            -- Reg pxie_dstara
            rd_ack_d0 <= rd_req;
            rd_dat_d0(2 downto 0) <= pxie_dstara_mux_reg;
            rd_dat_d0(31 downto 3) <= (others => '0');
          when "010100" =>
            -- Reg nic_fifo
            rd_ack_d0 <= rd_req;
            rd_dat_d0(15 downto 0) <= nic_fifo_max_count_i;
            rd_dat_d0(16) <= nic_fifo_full_i;
            rd_dat_d0(31 downto 17) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req;
          end case;
        when "1101" =>
          -- Submap si5340
          si5340_re <= rd_req;
          rd_dat_d0 <= si5340_i.dat;
          rd_ack_d0 <= si5340_rack;
        when "1110" =>
          case rd_addr(7 downto 2) is
          when "000000" =>
            -- Reg leds_force
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= leds_force_reg;
          when "000001" =>
            -- Reg leds_rgb_out_hi
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= leds_rgb_out_hi_reg;
          when "000010" =>
            -- Reg leds_rgb_out_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= leds_rgb_out_lo_reg;
          when "000011" =>
            -- Reg leds_rgb_in_hi
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= leds_rgb_in_hi_reg;
          when "000100" =>
            -- Reg leds_rgb_in_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= leds_rgb_in_lo_reg;
          when others =>
            rd_ack_d0 <= rd_req;
          end case;
        when "1111" =>
          -- Memory leds_colors
          leds_colors_re <= rd_req;
          leds_colors_rd_o <= leds_colors_rs;
          rd_dat_d0 <= leds_colors_dato_i;
          rd_ack_d0 <= leds_colors_rack_i;
        when others =>
          rd_ack_d0 <= rd_req;
        end case;
      when "0001" =>
        case rd_addr(11 downto 8) is
        when "0000" =>
          case rd_addr(7 downto 2) is
          when "000000" =>
            -- Reg rf_0_ftw_hi
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_ftw_hi_reg;
          when "000001" =>
            -- Reg rf_0_ftw_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_ftw_lo_reg;
          when "000010" =>
            -- Reg rf_0_ftw_load
            rd_ack_d0 <= rd_req;
          when "000011" =>
            -- Reg rf_0_bst_ctrl
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= rf_0_bst_ctrl_en_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "000100" =>
            -- Reg rf_0_h1
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_h1_reg;
          when "000101" =>
            -- Reg rf_0_gth_cfg
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_gth_cfg_reg;
          when "000110" =>
            -- Reg rf_0_gth_sta
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_gth_sta_i;
          when "000111" =>
            -- Reg rf_0_rf_ftw
            rd_ack_d0 <= rd_req;
            rd_dat_d0(15 downto 0) <= rf_0_rf_ftw_hi_i;
            rd_dat_d0(16) <= rf_0_rf_ftw_rst_i;
            rd_dat_d0(31 downto 17) <= (others => '0');
          when "001000" =>
            -- Reg rf_0_rf_ftw_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_rf_ftw_lo_i;
          when "001001" =>
            -- Reg rf_0_rf_rx_tai
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_rf_rx_tai_i;
          when "001010" =>
            -- Reg rf_0_rf_rx_cyc
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_0_rf_rx_cyc_i;
          when "001011" =>
            -- Reg rf_0_rf_rx_sta
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= rf_0_rf_rx_sta_valid_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req;
          end case;
        when "0001" =>
          -- Submap rf_0_streamer
          rf_0_streamer_re <= rd_req;
          rd_dat_d0 <= rf_0_streamer_i.dat;
          rd_ack_d0 <= rf_0_streamer_rack;
        when "0010" =>
          case rd_addr(7 downto 2) is
          when "000000" =>
            -- Reg rf_1_ftw_hi
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_ftw_hi_reg;
          when "000001" =>
            -- Reg rf_1_ftw_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_ftw_lo_reg;
          when "000010" =>
            -- Reg rf_1_ftw_load
            rd_ack_d0 <= rd_req;
          when "000011" =>
            -- Reg rf_1_bst_ctrl
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= rf_1_bst_ctrl_en_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "000100" =>
            -- Reg rf_1_h1
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_h1_reg;
          when "000101" =>
            -- Reg rf_1_gth_cfg
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_gth_cfg_reg;
          when "000110" =>
            -- Reg rf_1_gth_sta
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_gth_sta_i;
          when "000111" =>
            -- Reg rf_1_rf_ftw
            rd_ack_d0 <= rd_req;
            rd_dat_d0(15 downto 0) <= rf_1_rf_ftw_hi_i;
            rd_dat_d0(16) <= rf_1_rf_ftw_rst_i;
            rd_dat_d0(31 downto 17) <= (others => '0');
          when "001000" =>
            -- Reg rf_1_rf_ftw_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_rf_ftw_lo_i;
          when "001001" =>
            -- Reg rf_1_rf_rx_tai
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_rf_rx_tai_i;
          when "001010" =>
            -- Reg rf_1_rf_rx_cyc
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_1_rf_rx_cyc_i;
          when "001011" =>
            -- Reg rf_1_rf_rx_sta
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= rf_1_rf_rx_sta_valid_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req;
          end case;
        when "0011" =>
          -- Submap rf_1_streamer
          rf_1_streamer_re <= rd_req;
          rd_dat_d0 <= rf_1_streamer_i.dat;
          rd_ack_d0 <= rf_1_streamer_rack;
        when "0100" =>
          case rd_addr(7 downto 2) is
          when "000000" =>
            -- Reg rf_2_ftw_hi
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_ftw_hi_reg;
          when "000001" =>
            -- Reg rf_2_ftw_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_ftw_lo_reg;
          when "000010" =>
            -- Reg rf_2_ftw_load
            rd_ack_d0 <= rd_req;
          when "000011" =>
            -- Reg rf_2_bst_ctrl
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= rf_2_bst_ctrl_en_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "000100" =>
            -- Reg rf_2_h1
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_h1_reg;
          when "000101" =>
            -- Reg rf_2_gth_cfg
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_gth_cfg_reg;
          when "000110" =>
            -- Reg rf_2_gth_sta
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_gth_sta_i;
          when "000111" =>
            -- Reg rf_2_rf_ftw
            rd_ack_d0 <= rd_req;
            rd_dat_d0(15 downto 0) <= rf_2_rf_ftw_hi_i;
            rd_dat_d0(16) <= rf_2_rf_ftw_rst_i;
            rd_dat_d0(31 downto 17) <= (others => '0');
          when "001000" =>
            -- Reg rf_2_rf_ftw_lo
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_rf_ftw_lo_i;
          when "001001" =>
            -- Reg rf_2_rf_rx_tai
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_rf_rx_tai_i;
          when "001010" =>
            -- Reg rf_2_rf_rx_cyc
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= rf_2_rf_rx_cyc_i;
          when "001011" =>
            -- Reg rf_2_rf_rx_sta
            rd_ack_d0 <= rd_req;
            rd_dat_d0(0) <= rf_2_rf_rx_sta_valid_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req;
          end case;
        when "0101" =>
          -- Submap rf_2_streamer
          rf_2_streamer_re <= rd_req;
          rd_dat_d0 <= rf_2_streamer_i.dat;
          rd_ack_d0 <= rf_2_streamer_rack;
        when others =>
          rd_ack_d0 <= rd_req;
        end case;
      when "0010" =>
        case rd_addr(11 downto 11) is
        when "0" =>
          case rd_addr(10 downto 2) is
          when "000000000" =>
            -- Reg inputs_summary
            rd_ack_d0 <= rd_req;
            rd_dat_d0(2 downto 0) <= inputs_summary_rise_i;
            rd_dat_d0(5 downto 3) <= inputs_summary_fall_i;
            rd_dat_d0(31 downto 6) <= (others => '0');
          when "000010000" =>
            -- Reg inputs_csr_0_en
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_0_en_reg;
          when "000010001" =>
            -- Reg inputs_csr_0_rise_sr
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_0_rise_sr_i;
          when "000010010" =>
            -- Reg inputs_csr_0_fall_sr
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_0_fall_sr_i;
          when "000010011" =>
            -- Reg inputs_csr_1_en
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_1_en_reg;
          when "000010100" =>
            -- Reg inputs_csr_1_rise_sr
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_1_rise_sr_i;
          when "000010101" =>
            -- Reg inputs_csr_1_fall_sr
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_1_fall_sr_i;
          when "000010110" =>
            -- Reg inputs_csr_2_en
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_2_en_reg;
          when "000010111" =>
            -- Reg inputs_csr_2_rise_sr
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_2_rise_sr_i;
          when "000011000" =>
            -- Reg inputs_csr_2_fall_sr
            rd_ack_d0 <= rd_req;
            rd_dat_d0 <= inputs_csr_2_fall_sr_i;
          when others =>
            rd_ack_d0 <= rd_req;
          end case;
        when "1" =>
          -- Memory inputs_ts
          rd_dat_d0 <= inputs_ts_data_i;
          rd_ack_d0 <= inputs_ts_rack;
          inputs_ts_re <= rd_req;
        when others =>
          rd_ack_d0 <= rd_req;
        end case;
      when "1000" =>
        -- Submap pulser_group_0_el
        pulser_group_0_el_re <= rd_req;
        rd_dat_d0 <= pulser_group_0_el_i.dat;
        rd_ack_d0 <= pulser_group_0_el_rack;
      when "1001" =>
        -- Submap pulser_group_1_el
        pulser_group_1_el_re <= rd_req;
        rd_dat_d0 <= pulser_group_1_el_i.dat;
        rd_ack_d0 <= pulser_group_1_el_rack;
      when "1010" =>
        -- Submap pulser_group_2_el
        pulser_group_2_el_re <= rd_req;
        rd_dat_d0 <= pulser_group_2_el_i.dat;
        rd_ack_d0 <= pulser_group_2_el_rack;
      when "1011" =>
        -- Submap pulser_group_3_el
        pulser_group_3_el_re <= rd_req;
        rd_dat_d0 <= pulser_group_3_el_i.dat;
        rd_ack_d0 <= pulser_group_3_el_rack;
      when others =>
        rd_ack_d0 <= rd_req;
      end case;
    when "1" =>
      -- Submap wrnic
      wrnic_re <= rd_req;
      rd_dat_d0 <= wrnic_i.dat;
      rd_ack_d0 <= wrnic_rack;
    when others =>
      rd_ack_d0 <= rd_req;
    end case;
  end process;
end syn;
